<?php

require_once dirname(__FILE__) . '/_redirect_data.php';

function ncms_resources_redirect() {
    $url = $_SERVER['REQUEST_URI'];
    if (strpos($url, '?') !== false) {
        list($url, $query) = explode('?', $url, 2);
    }
    if (empty($query)) {
        $query = '';
    } else {
        $query = '?' . $query;
    }

    if (strpos($url, '.php') === false && is_file(get_template_directory() . $url)) {
        wp_safe_redirect(get_template_directory_uri() . $_SERVER['REQUEST_URI'] . $query);
        exit();
    }

    $pathParts = array_values(array_filter(explode('/', $url)));
    if (count($pathParts) == 3 && $pathParts[0] == 'buildmaster' && $pathParts[1] == 'extensions') {
        wp_safe_redirect('/den/' . strtolower($pathParts[2]) . $query, 301);
        exit();
    }
    if (count($pathParts) == 3 && $pathParts[0] == 'den' && in_array($pathParts[1], array('inedox', 'buildmaster', 'otter', 'proget'))) {
        wp_safe_redirect('/den/' . strtolower($pathParts[2]) . $query, 301);
        exit();
    }
    global $ncms_forum_ids;
    if (count($pathParts) == 3 && $pathParts[0] == 'support' && $pathParts[1] == 'questions' && isset($ncms_forum_ids[$pathParts[2]])) {
        wp_redirect('https://forums.inedo.com/topic/' . $ncms_forum_ids[$pathParts[2]] . $query, 301);
        exit();
    }

    if (count($pathParts) >= 2 && $pathParts[0] == 'support' && $pathParts[1] == 'documentation') {
        array_splice($pathParts, 0, 2, array('https://docs.inedo.com/docs'));
        wp_redirect(implode('/', $pathParts) . $query, 301);
        exit();
    }
    if (count($pathParts) >= 2 && $pathParts[0] == 'support' && $pathParts[1] == 'sdk-reference') {
        array_splice($pathParts, 0, 2, array('https://docs.inedo.com/sdk'));
        wp_redirect(implode('/', $pathParts) . $query, 301);
        exit();
    }
    global $ncms_blog_redirects;
    if (count($pathParts) == 2 && $pathParts[0] == 'blog' && isset($ncms_blog_redirects[$pathParts[1]])) {
        wp_redirect($ncms_blog_redirects[$pathParts[1]] . $query, 301);
        exit();
    }
    if (count($pathParts) >= 1 && $pathParts[0] == 'blog') {
        wp_redirect('https://blog.inedo.com' . $query, 301);
        exit();
    }
    if (count($pathParts) >= 2 && $pathParts[0] == 'jp' && $pathParts[1] == 'blog') {
        wp_redirect('https://blog.inedo.com/jp' . $query, 301);
        exit();
    }

    global $ncms_kb_ids;
    if (count($pathParts) >= 3 && $pathParts[0] == 'support' && $pathParts[1] == 'kb' && isset($ncms_kb_ids[$pathParts[2]])) {
        if (strpos($ncms_kb_ids[$pathParts[2]], '?') !== false) {
            $query = str_replace('?', '&', $query);
        }
        wp_redirect($ncms_kb_ids[$pathParts[2]] . $query, 301);
        exit();
    }

    if (count($pathParts) >= 1 && $pathParts[0] == 'den' && $pathParts[1] == 'feed') {
        array_splice($pathParts, 0, 2, array('https://proget.inedo.com/upack/Extensions'));
        wp_redirect(implode('/', $pathParts) . $query, 307);
        exit();
    }
    if (count($pathParts) >= 1 && $pathParts[0] == 'products' && $pathParts[1] == 'feed') {
        array_splice($pathParts, 0, 2, array('https://proget.inedo.com/upack/Products'));
        wp_redirect(implode('/', $pathParts) . $query, 307);
        exit();
    }
    if (count($pathParts) == 2 && in_array($pathParts[0], array('bm', 'ot', 'pg')) && $pathParts[1] == 'activate') {
        wp_redirect('https://my.inedo.com/services/v1/activate' . $query, 307);
        exit();
    }
    if (count($pathParts) > 2 && $pathParts[0] == 'files' && in_array($pathParts[1], array('buildmaster', 'otter', 'proget'))) {
        $pathParts[0] = $pathParts[1];
        $pathParts[1] = 'download';
    }
    if (count($pathParts) > 2 && in_array($pathParts[0], array('buildmaster', 'otter', 'proget', 'romp')) && $pathParts[1] == 'download') {
        array_splice($pathParts, 1, 1);
        array_splice($pathParts, 0, 0, array('https://my.inedo.com/services/legacy/downloads'));
        wp_redirect(implode('/', $pathParts) . $query, 307);
        exit();
    }
    if (count($pathParts) > 2 && $pathParts[0] == 'files' && $pathParts[1] == 'buildmaster-extensions') {
        array_splice($pathParts, 0, 2, array('https://my.inedo.com/services/legacy/downloads/extension'));
        wp_redirect(implode('/', $pathParts) . $query, 307);
        exit();
    }
    if (count($pathParts) >= 2 && $pathParts[0] == 'bm' && $pathParts[1] == 'update') {
        array_splice($pathParts, 0, 2, array('https://my.inedo.com/services/legacy/updates/buildmaster'));
        wp_redirect(implode('/', $pathParts) . $query, 307);
        exit();
    }
    if (count($pathParts) == 2 && $pathParts[0] == 'bm' && $pathParts[1] == 'submit-error-report') {
        wp_redirect('https://my.inedo.com/services/legacy/reporting/submit-error-report' . $query, 307);
        exit();
    }
    if (count($pathParts) == 2 && $pathParts[0] == 'ot' && $pathParts[1] == 'update') {
        wp_redirect('https://my.inedo.com/services/legacy/updates/otter' . $query, 307);
        exit();
    }
    if (count($pathParts) == 2 && $pathParts[0] == 'pg' && $pathParts[1] == 'update') {
        wp_redirect('https://my.inedo.com/services/legacy/updates/proget' . $query, 307);
        exit();
    }
    if (count($pathParts) >= 2 && in_array($pathParts[0], array('buildmaster', 'otter', 'proget')) && $pathParts[1] == 'versions') {
        array_splice($pathParts, 0, 0, array('https://my.inedo.com'));
        wp_redirect(implode('/', $pathParts) . $query, 307);
        exit();
    }
    if (count($pathParts) == 3 && $pathParts[0] == 'proget' && $pathParts[1] == 'activation' && $pathParts[2] == 'request-key') {
        wp_redirect('https://my.inedo.com/services/legacy/licensing/request-pg-key' . $query, 307);
        exit();
    }
    if (count($pathParts) == 2 && in_array($pathParts[0], array('bm', 'ot', 'pg')) && $pathParts[1] == 'request-key') {
        wp_redirect('https://my.inedo.com/services/legacy/licensing/request-' . $pathParts[0] . '-key' . $query, 307);
        exit();
    }
}
add_action('parse_request', 'ncms_resources_redirect', -1); // run before Safe Redirect Manager
