//import { __experimentalLinkControl as LinkControl } from '@wordpress/block-editor';
(function (blocks, editor, i18n, element, components, _) {
	var el = element.createElement;
	

	function buttonEdit(props, textProp, urlProp, name, sizeProp, boldProp, defaultSize, wrapped, btnClass, btnStyle, ctaProp) {
		textProp = textProp || 'button_text';
		urlProp = urlProp || 'button_url';
		name = name || 'Button';
		wrapped = wrapped;
		btnClass = btnClass || 'btn-primary';
		ctaProp = ctaProp === undefined ? '' : ctaProp;

		var fontSizePicker;

		let btn = function() { 
			return el('span',
				{
					className: 'btn ' + (btnStyle && props.attributes[btnStyle] || btnClass),
					style: {
						fontSize: sizeProp && (props.attributes[sizeProp] + 'px'),
						fontWeight: boldProp && (props.attributes[boldProp] ? 'bold' : 'normal')
					}
				},
				props.attributes[textProp]
			)
		};

		return props.isSelected ? el(components.Panel, {},
			el(components.PanelBody, {},
				el(components.PanelRow, {},
					el(editor.URLInput, {
						label: name + ' URL',
						hasBorder: true,
						isFullWidth: true,
						autoFocus: false,
						value: props.attributes[urlProp],
						onChange: function (url) {
							var toSet = {};
							toSet[urlProp] = url;
							props.setAttributes(toSet);
						}
					})
				),
				el(components.PanelRow, {},
					el(components.TextControl, {
						label: name + ' Label',
						value: props.attributes[textProp],
						onChange: function (text) {
							var toSet = {};
							toSet[textProp] = text;
							props.setAttributes(toSet);
						}
					})
				),
				sizeProp && el(components.PanelRow, {},
					el(components.FontSizePicker, {
						value: props.attributes[sizeProp],
						onChange: function (size) {
							var toSet = {};
							toSet[sizeProp] = size || defaultSize;
							props.setAttributes(toSet);
						}
					})
				),
				boldProp && el(components.ToggleControl, {
					label: 'Bold',
					checked: props.attributes[boldProp],
					onChange: function (bold) {
						var toSet = {};
						toSet[boldProp] = bold;
						props.setAttributes(toSet);
					}
				}),
				btnStyle && el(components.SelectControl , {
					label: 'Button Style',
					value: props.attributes[btnStyle],
					options: [
						{
							value: 'is-style-btn-primary',
							label: 'Primary'
						},
						{
							value: 'is-style-btn-blue',
							label: 'Blue',
						},
						{
							value: 'is-style-btn-blue-hollow',
							label: 'Blue Hollow'
						},
						{
							value: 'is-style-btn-yellow',
							label: 'Yellow'
						},
						{
							value: 'is-style-btn-yellow-hollow',
							label: 'Yellow Hollow'
						},
						{
							value: 'is-style-btn-dark-blue',
							label: 'Dark Blue'
						},
						{
							value: 'is-style-btn-dark-blue-hollow',
							label: 'Dark Blue Hollow'
						},
						{
							value: 'is-style-btn-white',
							label: 'White'
						},
						{
							value: 'is-style-btn-white-hollow',
							label: 'White Hollow'
						}
					],
					onChange: function (value) {
						var toSet = {};
						toSet[btnStyle] = value;
						props.setAttributes(toSet);
					}
				}),
				ctaProp && el(components.PanelRow, {},
					el(components.TextControl, {
						label: name + ' CTA ID',
						value: props.attributes[ctaProp],
						onChange: function (text) {
							var toSet = {};
							toSet[ctaProp] = text;
							props.setAttributes(toSet);
						}
					})
				)
			)
		) : props.attributes[urlProp] ? 
				wrapped ? el('div',
					{ className: 'text-center ' + props.attributes[btnStyle] },
					btn()
				) 
				: btn() 
			: el('span');
	}

	function buttonSave(attributes, textProp, urlProp, ctaProp, className){
		textProp = textProp || 'button_text';
		urlProp = urlProp || 'button_url';
		className = className === undefined ? 'btn-primary' : className;
		ctaProp = ctaProp === undefined ? '' : ctaProp;
		
		return ctaProp && attributes[ctaProp] && attributes[ctaProp] !== undefined ?
			[
				el('span', { class: "hs-cta-wrapper", id: ("hs-cta-wrapper-" + attributes[ctaProp]) }, 
					el('span', {class: ("hs-cta-node hs-cta-" + attributes[ctaProp]), id: ("hs-cta-" + attributes[ctaProp])}, 
						el('a', {
								href: 'https://cta-redirect.hubspot.com/cta/redirect/5416872/' + attributes[ctaProp], class: 'btn ' + className
							}, 
							el('img', {
								class: 'hs-cta-img',  
								id: ('hs-cta-img-' + attributes[ctaProp]), 
								style: { borderWidth: '0px'}, 
								src: ('https://no-cache.hubspot.com/cta/default/5416872/' + attributes[ctaProp] + '.png'),  
								alt: 'Inedo'
							})
						)
					),
					el('script', {charset:"utf-8", src:"https://js.hscta.net/cta/current.js"}),
					el('script', {type:"text/javascript"}, "hbspt.cta.load(5416872, '" + attributes[ctaProp] + "', {});")
				)
			]
			: el('a', {
				href: attributes[urlProp], 
				class: 'btn ' + className
			}, attributes[textProp]);
	}

	function imageEdit(props, attr) {
		attr = attr || 'image';
		return props.isSelected || !props.attributes[attr] || !props.attributes[attr].url ? el(editor.MediaPlaceholder, {
			onSelect: function (media) {
				var toSet = {};
				toSet[attr] = { id: media.id, url: media.url, alt: media.alt };
				props.setAttributes(toSet);
			},
			allowedTypes: ['image'],
			value: props.attributes[attr],
			mediaPreview: props.attributes[attr] && el('img', {
				className: 'img-fluid',
				src: props.attributes[attr].url
			})
		}, 
			props.attributes[attr] && props.attributes[attr].url ? [el(components.Button, {
				isSecondary: true,
				onClick: function()
				{
					var toSet = {};
					toSet[attr] = {};
					props.setAttributes(toSet);
				}
			}, 'Remove Image'),
			el(components.TextControl, {
				label: 'Image Width in px',
				value: props.attributes[attr].width,
				onChange: function (text) {
					var toSet = {};
					toSet[attr] = { width: text, id: props.attributes[attr].id, url: props.attributes[attr].url, alt: props.attributes[attr].alt };
					props.setAttributes(toSet);
				}
			})
			] : ''
		) : el('img', {
			className: 'img-fluid',
			style: { width: (props.attributes[attr] && props.attributes[attr].width) || null },
			src: props.attributes[attr].url
		});
	}
	
	blocks.registerBlockType('inedo/page-banner', {
		title: 'Page Banner',
		category: 'layout',
		styles: [
			{
				name: 'default',
				label: 'Default',
				isDefault: true
			},
			{
				name: 'banner-shorter',
				label: 'Shorter'
			}			
		],
		attributes: {
			heading: {
				type: 'string',
				source: 'html',
				selector: 'h1'
			},
			content: {
				type: 'string',
				source: 'html',
				selector: 'p'
			},
			button_text: {
				type: 'string'
			},
			button_url: {
				type: 'string'
			},
			button_cta: {
				type: 'string'
			},
			button_style: {
				type: 'string',
				default: 'is-style-btn-primary'
			},
			image: {
				type: 'object'
			}
		},

		example: {
			attributes: {
				heading: 'Source Control',
				content: 'Use your current tech stack to interact with your source code however you want across all of your systems and branches.',
				button_url: '#',
				button_text: 'Create Free BuildMaster Account',
				image: {
					url: '/codex/banner.png',
					alt: ''
				}
			}
		},

		edit: function (props) {
			return el('div', { className: 'banner' },
				el('div', { className: 'container' },
					el('div', { className: 'row' },
						el('div', { className: 'col-md-6' },
							el('div', { className: 'left_side' },
								el(editor.RichText, {
									tagName: 'h1',
									onChange: function (content) {
										props.setAttributes({ heading: content });
									},
									value: props.attributes.heading,
									placeholder: 'Heading',

								}),
								el(editor.RichText, {
									tagName: 'p',
									onChange: function (content) {
										props.setAttributes({ content: content });
									},
									value: props.attributes.content,
									placeholder: 'Content goes here.'
								}),
								buttonEdit(props, null, null, null, null, null, null, true, null, 'button_style', 'button_cta')
							)
						),
						el('div', { className: 'col-md-6' },
							el('div', { className: 'right_side' },
								imageEdit(props)
							)
						)
					)
				)
			);
		},
		save: function (props) {
			return el('div', { className: 'banner' },
				el('div', { className: 'container' },
					el('div', { className: 'row' },
						el('div', { className: 'col-md-6' },
							el('div', { className: 'left_side' },
								el(editor.RichText.Content, {
									tagName: 'h1',
									value: props.attributes.heading
								}),
								el(editor.RichText.Content, {
									tagName: 'p',
									value: props.attributes.content
								}),
								props.attributes.button_url && el('div', {class: props.attributes.button_style }, buttonSave(props.attributes, 'button_text', 'button_url', 'button_cta', ''))
							)
						),
						props.attributes.image && props.attributes.image.url && el('div', { className: 'col-md-6' },
							el('div', { className: 'right_side' },
								el('img', {
									className: 'img-fluid',
									src: props.attributes.image.url,
									alt: props.attributes.image.alt,
									style: { width: (props.attributes.image && props.attributes.image.width) || null }
								})
							)
						)
					)
				)
			);
		}
	});

	blocks.registerBlockType('inedo/inedo-button', {
		title: 'Inedo Button',
		category: 'layout',
		styles: [
			{
				name: 'btn-primary',
				label: 'Primary',
				isDefault: true
			},
			{
				name: 'btn-blue',
				label: 'Blue',
			},
			{
				name: 'btn-blue-hollow',
				label: 'Blue Hollow'
			},
			{
				name: 'btn-yellow',
				label: 'Yellow'
			},
			{
				name: 'btn-yellow-hollow',
				label: 'Yellow Hollow'
			},
			{
				name: 'btn-dark-blue',
				label: 'Dark Blue'
			},
			{
				name: 'btn-dark-blue-hollow',
				label: 'Dark Blue Hollow'
			},
			{
				name: 'btn-white',
				label: 'White'
			},
			{
				name: 'btn-white-hollow',
				label: 'White Hollow'
			}
		],
		attributes: {
			button_align: {
				type: 'string',
				default: 'text-center'
			},
			button1_text: {
				type: 'string'
			},
			button1_url: {
				type: 'string'
			},
			button1_cta: {
				type: 'string'
			},
			button2_text: {
				type: 'string'
			},
			button2_url: {
				type: 'string'
			},
			button2_cta: {
				type: 'string'
			},
			two_buttons: {
				type: 'bool',
				default: false
			}
		},
		edit: function (props) {
			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: 'arrow-left',
								title: 'Left Align',
								isActive: props.attributes.button_align == 'text-left',
								onClick: function () {
									props.setAttributes({ button_align: 'text-left', two_buttons: false  });
								}
							},
							{
								icon: 'arrow-up',
								title: 'Center Align',
								isActive: props.attributes.button_align == 'text-center',
								onClick: function () {
									props.setAttributes({ button_align: 'text-center', two_buttons: false  });
								}
							},
							{
								icon: 'arrow-right',
								title: 'Right Align',
								isActive: props.attributes.button_align == 'text-right',
								onClick: function () {
									props.setAttributes({ button_align: 'text-right', two_buttons: false  });
								}
							},
							{
								icon: 'leftright',
								title: 'Two Button',
								isActive: props.attributes.button_align == 'two buttons',
								onClick: function () {
									props.setAttributes({ button_align: 'two-buttons', two_buttons: true });
								}
							}
						]
					})
				),
				//props, textProp, urlProp, name, sizeProp, boldProp, defaultSize, wrapped, btnClass
				el('div', 
					{class: 'btn-block container ' + props.attributes.button_align + ' ' + props.attributes.className }, 
					buttonEdit(props, 'button1_text', 'button1_url', 'Button 1', null, null, null, false, ' ', null, 'button1_cta'),
					props.attributes.two_buttons ? 
						buttonEdit(props, 'button2_text', 'button2_url', 'Button 2', null, null, null, false, ' ', null, 'button2_cta') 
						: null
				)
			];
		},
		save: function (props) {
			return el('div', {
					className: 'btn-block container ' + props.attributes.button_align + ' ' + props.attributes.className 
				}, 
				buttonSave(props.attributes, 'button1_text', 'button1_url', 'button1_cta'),
				props.attributes.two_buttons ? 
					buttonSave(props.attributes, 'button2_text', 'button2_url', 'button2_cta') : ''
			);
		}
	});

	blocks.registerBlockType('inedo/inedo-link-block', {
		title: 'Inedo Link Block',
		category: 'layout',
		styles: [
			{
				name: 'default',
				label: 'Default',
				isDefault: true,
			},
			{
				name: 'hover-shadow',
				label: 'Hover Styles',
				isDefault: false,
			}
		],
		attributes: {
			href: {
				type: 'string'
			},
			title: {
				type: 'string'
			},
			opensInNewTab: {
				type: 'boolean'
			}
		},
		edit: function (props) {
			

			var content = el(editor.InnerBlocks, {
				//allowedBlocks: ['core/heading', 'core/paragraph', 'inedo/slider', 'inedo/inedo-button', 'inedo/hubspot-form']
			});
			return [
				el(editor.InspectorControls, {  },
				el(components.Panel, {},
					el(components.PanelBody, {},
						el(components.PanelRow, {},
							editor.__experimentalLinkControl({
								value: { 
									url: props.attributes.href ? props.attributes.href : '',
									title: props.attributes.title ?  props.attributes.title : '',
									opensInNewTab: props.attributes.opensInNewTab
								},
								forceIsEditingLink: true,
								onChange: function (newValue) {
									var toSet = {};
									toSet['href'] = newValue.url ? newValue.url : '';
									toSet['title'] = newValue.title ? newValue.title : '';
									toSet['opensInNewTab'] = newValue.opensInNewTab;
									props.setAttributes(toSet);
								}
							}),

						)
					)
				)
				)
				,
				//props, textProp, urlProp, name, sizeProp, boldProp, defaultSize, wrapped, btnClass
				el('div', 
						{
							'href': (props.attributes.href ? props.attributes.href : ''), 
							'title': props.attributes.title ? props.attributes.title : '', 
							'target': props.attributes.opensInNewTab ? '_blank': '_self',
							'className': 'wp-block-inedo-inedo-link-block ' + props.attributes.className,
							'rel': ''
						}, 
						content
					)
			];
		},
		save: function (props) {
			var content = el(editor.InnerBlocks.Content, {});
			return el('a', 
					{
						'className': 'wp-block-inedo-inedo-link-block ' + props.attributes.className, 
						'href': (props.attributes.href ? props.attributes.href : ''), 
						'title': props.attributes.title ? props.attributes.title : '', 
						'target': props.attributes.opensInNewTab ? '_blank': '_self',
						'rel': 'noopener noreferrer' 
					}, 
					content
				)
		}
	});

	blocks.registerBlockType('inedo/inedo-wizard-button', {
		title: 'Inedo Wizard Button',
		category: 'layout',
		styles: [
			{
				name: 'btn-primary',
				label: 'Primary',
				isDefault: true
			},
			{
				name: 'btn-blue',
				label: 'Blue',
			},
			{
				name: 'btn-blue-hollow',
				label: 'Blue Hollow'
			},
			{
				name: 'btn-yellow',
				label: 'Yellow'
			},
			{
				name: 'btn-yellow-hollow',
				label: 'Yellow Hollow'
			}
		],
		attributes: {
			button_align: {
				type: 'string',
				default: 'two-buttons'
			},
			button1_text: {
				type: 'string'
			},
			button1_url: {
				type: 'string'
			},
			button1_cta: {
				type: 'string'
			},
			button2_text: {
				type: 'string'
			},
			button2_url: {
				type: 'string'
			},
			button2_cta: {
				type: 'string'
			},
			two_buttons: {
				type: 'bool',
				default: false
			}
		},
		edit: function (props) {
			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: 'arrow-left',
								title: 'Left Align',
								isActive: props.attributes.button_align == 'text-left',
								onClick: function () {
									props.setAttributes({ button_align: 'text-left', two_buttons: false  });
								}
							},
							{
								icon: 'arrow-right',
								title: 'Right Align',
								isActive: props.attributes.button_align == 'text-right',
								onClick: function () {
									props.setAttributes({ button_align: 'text-right', two_buttons: false  });
								}
							},
							{
								icon: 'leftright',
								title: 'Two Button',
								isActive: props.attributes.button_align == 'two buttons',
								onClick: function () {
									props.setAttributes({ button_align: 'two-buttons', two_buttons: true });
								}
							}
						]
					})
				),
				//props, textProp, urlProp, name, sizeProp, boldProp, defaultSize, wrapped, btnClass
				el('div', 
					{className: 'btn-block wizard-btn container ' + props.attributes.button_align + ' ' + props.attributes.className }, 
					el('div', { class: props.attributes.button_align == 'text-right' ? 'btn-item  text-right' : 'btn-item '}, 
						buttonEdit(props, 'button1_text', 'button1_url', 'Button 1', null, null, null, false, ' ', null, 'button1_cta'),
						el('br'),
						props.attributes.button_align == 'text-right' ?  
							el('p', { class: 'btn-note'}, 'next →') 
							:  el('p', { class: 'btn-note'}, '← go back')
					),
					props.attributes.two_buttons ? 
						el('div', { class: 'btn-item text-right' }, 
							buttonEdit(props, 'button2_text', 'button2_url', 'Button 2', null, null, null, false, ' ', null, 'button2_cta') ,
							el('br'),
							el('p', { class: 'btn-note'}, 'next →')
						)
						: null
				)
			];
		},
		save: function (props) {
			return el('div', {className: 'btn-block wizard-btn container ' + props.attributes.button_align + ' ' + props.attributes.className }, 
				el('div', { class: props.attributes.button_align == 'text-right' ? 'btn-item  text-right' : 'btn-item ' }, 
					buttonSave(props.attributes, 'button1_text', 'button1_url', 'button1_cta'),
					el('br'),
					props.attributes.button_align == 'text-right' ?  
						el('p', {class: 'btn-note'}, 'next →') 
						:  el('p', {class: 'btn-note'}, '← go back')
				),
				props.attributes.two_buttons ? 
				el('div', { class: 'btn-item text-right' }, 
					buttonSave(props.attributes, 'button2_text', 'button2_url', 'button2_cta'),
					el('br'),
					el('p', { class: 'btn-note'}, 'next →')
				) : ''
			)
		}
	});

	blocks.registerBlockType('inedo/key-points', {
		title: 'Key Points',
		category: 'layout',
		attributes: {
			overlap: {
				type: 'boolean',
				default: false
			},
			count: {
				type: 'integer',
				default: 3
			},
			image0: {
				type: 'object'
			},
			image1: {
				type: 'object'
			},
			image2: {
				type: 'object'
			},
			image3: {
				type: 'object'
			},
			text0: {
				type: 'string'
			},
			text1: {
				type: 'string'
			},
			text2: {
				type: 'string'
			},
			text3: {
				type: 'string'
			},
			url0: {
				type: 'string'
			},
			url1: {
				type: 'string'
			},
			url2: {
				type: 'string'
			},
			url3: {
				type: 'string'
			}
		},

		example: {
			attributes: {
				count: 3,
				text0: 'Your Current Tech Stack',
				text1: 'Effortless Parallel Development',
				text2: 'Tag Versions & Releases',
				image0: {
					url: '/codex/key1.png',
					alt: ''
				},
				image1: {
					url: '/codex/key2.png',
					alt: ''
				},
				image2: {
					url: '/codex/key3.png',
					alt: ''
				}
			}
		},

		edit: function (props) {
			var count = props.attributes.count;

			var boxes = [];
			for (var i = 0; i < count; i++) {
				boxes.push(el('div', { className: 'col-md-' + (12 / count) },
					el('div', { className: 'box text-center' },
						el(editor.URLInputButton, {
							url: props.attributes['url' + i],
							onChange: function (i) {
								return function (url) {
									var toSet = {};
									toSet['url' + i] = url;
									props.setAttributes(toSet);
								};
							}(i)
						}),
						imageEdit(props, 'image' + i),
						el(editor.RichText, {
							tagName: 'p',
							allowedFormats: [],
							onChange: function (i) {
								return function (content) {
									var toSet = {};
									toSet['text' + i] = content;
									props.setAttributes(toSet);
								};
							}(i),
							value: props.attributes['text' + i],
							placeholder: 'Description'
						})
					)
				));
			}

			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: 'upload',
								title: 'Overlap Previous',
								isActive: props.attributes.overlap,
								onClick: function () {
									props.setAttributes({ overlap: !props.attributes.overlap });
								}
							}
						]
					}),
					el(components.Toolbar, {
						controls: [
							{
								icon: 'slides',
								subscript: '2',
								title: 'Two Boxes',
								isActive: count == 2,
								onClick: function () {
									props.setAttributes({ count: 2 });
								}
							},
							{
								icon: 'slides',
								subscript: '3',
								title: 'Three Boxes',
								isActive: count == 3,
								onClick: function () {
									props.setAttributes({ count: 3 });
								}
							},
							{
								icon: 'slides',
								subscript: '4',
								title: 'Four Boxes',
								isActive: count == 4,
								onClick: function () {
									props.setAttributes({ count: 4 });
								}
							}
						]
					})
				),
				el('div', { className: 'boxes' + (props.attributes.overlap ? ' overlap' : '') },
					el('div', { className: 'container' },
						el('div', { className: 'row' }, boxes)
					)
				)
			];
		},
		save: function (props) {
			var count = props.attributes.count;

			var boxes = [];
			for (var i = 0; i < count; i++) {
				var inner = el('div', { className: 'box text-center' },
					el('img', {
						className: 'img-fluid',
						src: props.attributes['image' + i] && props.attributes['image' + i].url,
						alt: props.attributes['image' + i] && props.attributes['image' + i].alt
					}),
					el(editor.RichText.Content, {
						tagName: 'p',
						value: props.attributes['text' + i]
					})
				);
				boxes.push(el('div', { className: 'col-md-' + (12 / count) },
					props.attributes['url' + i] ? el('a', { href: props.attributes['url' + i] }, inner) : inner
				));
			}

			return el('div', { className: 'boxes' + (props.attributes.overlap ? ' overlap' : '') },
				el('div', { className: 'container' },
					el('div', { className: 'row' }, boxes)
				)
			);
		}
	});

	blocks.registerBlockType('inedo/page-split-content', {
		title: 'Page Split Content',
		category: 'layout',

		styles: [
			{
				name: 'none',
				label: 'None',
				isDefault: true
			},
			{
				name: 'border-top',
				label: 'Border Top'
			},
			{
				name: 'solid',
				label: 'Solid'
			},
			{
				name: 'shapes1',
				label: 'Shapes 1'
			},
			{
				name: 'shapes2',
				label: 'Shapes 2'
			},
			{
				name: 'shapes3',
				label: 'Shapes 3'
			},
			{
				name: 'shapes4',
				label: 'Shapes 4'
			}
		],
		attributes: {
			size: {
				type: 'integer',
				default: 6
			},
			heading: {
				type: 'string'
			},
			image: {
				type: 'object'
			},
			image_align: {
				type: 'string',
				default: 'left'
			},
			image_hide_mobile: {
				type: 'boolean'
			},
			button_align: {
				type: 'string',
				default: 'none'
			},
			button_text: {
				type: 'string'
			},
			button_cta: {
				type: 'string'
			},
			button_url: {
				type: 'string'
			},
			button_style: {
				type: 'string'
			}
		},

		example: {
			attributes: {
				button_align: 'right',
				button_url: '#',
				button_text: 'Let’s Get Started',
				image: {
					url: '/codex/split1.png',
					alt: ''
				},
				image_align: 'left'
			},
			innerBlocks: [
				{
					name: 'core/heading',
					attributes: {
						level: 3,
						content: 'Use the Tools You Want, However You Want to Use Them.'
					}
				},
				{
					name: 'core/paragraph',
					attributes: {
						content: 'Eliminate the problems caused by monolithic DevOps tools that force you to do things their way. BuildMaster provides a direct link to source control so you can use whatever tool you want, in whatever configuration you want.'
					}
				}
			]
		},

		edit: function (props) {
			var image = imageEdit(props);
			
			var content = el(editor.InnerBlocks, {
				allowedBlocks: ['core/heading', 'core/paragraph', 'inedo/slider', 'inedo/inedo-button', 'inedo/hubspot-form'],
				template: [
					['core/heading', { level: 3 }],
					['core/paragraph', {}]
				],
				templateInsertUpdatesSelection: false
			});

			var button = buttonEdit(props, null, null, null, null, null, null, true, null, 'button_style', 'button_cta');

			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: el('svg', {}),
								subscript: '4/8',
								title: '4/8 Split',
								isActive: props.attributes.size == 4,
								onClick: function () {
									props.setAttributes({ size: 4 });
								}
							},
							{
								icon: el('svg', {}),
								subscript: '5/7',
								title: '5/7 Split',
								isActive: props.attributes.size == 5,
								onClick: function () {
									props.setAttributes({ size: 5 });
								}
							},
							{
								icon: el('svg', {}),
								subscript: '6/6',
								title: '6/6 Split',
								isActive: props.attributes.size == 6,
								onClick: function () {
									props.setAttributes({ size: 6 });
								}
							},
							{
								icon: el('svg', {}),
								subscript: '7/5',
								title: '7/5 Split',
								isActive: props.attributes.size == 7,
								onClick: function () {
									props.setAttributes({ size: 7 });
								}
							},
							{
								icon: el('svg', {}),
								subscript: '8/4',
								title: '8/4 Split',
								isActive: props.attributes.size == 8,
								onClick: function () {
									props.setAttributes({ size: 8 });
								}
							}
						]
					}),
					el(components.Toolbar, {
						controls: [
							{
								icon: 'smartphone',
								title: 'Hide Image on Mobile',
								isActive: props.attributes.image_hide_mobile,
								onClick: function () {
									props.setAttributes({ image_hide_mobile: !props.attributes.image_hide_mobile });
								}
							},
							{
								icon: 'align-left',
								title: 'Left Image',
								isActive: props.attributes.image_align == 'left',
								onClick: function () {
									props.setAttributes({ image_align: 'left' });
								}
							},
							{
								icon: 'align-right',
								title: 'Right Image',
								isActive: props.attributes.image_align == 'right',
								onClick: function () {
									props.setAttributes({ image_align: 'right' });
								}
							}
						]
					}),
					el(components.Toolbar, {
						controls: [
							{
								icon: 'arrow-left-alt',
								title: 'Left Button',
								isActive: props.attributes.button_align == 'left',
								onClick: function () {
									props.setAttributes({ button_align: 'left' });
								}
							},
							{
								icon: 'dismiss',
								title: 'No Button',
								isActive: props.attributes.button_align == 'none',
								onClick: function () {
									props.setAttributes({ button_align: 'none' });
								}
							},
							{
								icon: 'arrow-right-alt',
								title: 'Right Button',
								isActive: props.attributes.button_align == 'right',
								onClick: function () {
									props.setAttributes({ button_align: 'right' });
								}
							}
						]
					})
				),
				el('div', { className: 'split-content ' + props.attributes.className },
					el('div', { className: 'container' },
						(props.isSelected || props.attributes.heading) && el(editor.RichText, {
							tagName: 'h2',
							className: 'text-center',
							allowedFormats: [],
							onChange: function (content) {
								props.setAttributes({ heading: content });
							},
							value: props.attributes.heading,
							placeholder: 'Heading'
						}),
						el('div', { className: 'row' },
							el('div', { className: 'col-md-' + props.attributes.size },
								props.attributes.image_align == 'left' ? image : content,
								props.attributes.button_align == 'left' && button
							),
							el('div', { className: 'col-md-' + (12 - props.attributes.size) },
								props.attributes.image_align == 'right' ? image : content,
								props.attributes.button_align == 'right' && button
							)
						)
					)
				)
			];
		},
		save: function (props) {
			var image = props.attributes.image && el('img', {
				className: props.attributes.image_hide_mobile ? 'img-fluid d-none d-md-inline' : 'img-fluid',
				src: props.attributes.image.url,
				alt: props.attributes.image.alt
			});
			var content = el(editor.InnerBlocks.Content, {});
			var button = props.attributes.button_url && el('div', { className: 'text-center ' + props.attributes.button_style },
				buttonSave(props.attributes, 'button_text', 'button_url', 'button_cta', 'btn_primary')
			);

			return el('div', { className: 'split-content ' + props.attributes.className },
				el('div', { className: 'container' },
					props.attributes.heading && el(editor.RichText.Content, {
						tagName: 'h2',
						className: 'text-center',
						value: props.attributes.heading
					}),
					el('div', { className: 'row' },
						el('div', { className: 'col-md-' + props.attributes.size },
							props.attributes.image_align == 'left' ? image : content,
							props.attributes.button_align == 'left' && button
						),
						el('div', { className: 'col-md-' + (12 - props.attributes.size) },
							props.attributes.image_align == 'right' ? image : content,
							props.attributes.button_align == 'right' && button
						)
					)
				)
			);
		}
	});

	blocks.registerBlockType('inedo/slider', {
		title: 'Slider',
		category: 'layout',

		supports: {
			html: false
		},

		attributes: {
			id: {
				type: 'string'
			}
		},

		example: {
			innerBlocks: [
				{
					name: 'inedo/slider-item',
					attributes: {
						className: 'active',
						image: {
							url: '/codex/slider.png',
							alt: ''
						},
						heading: 'Case study slider copy',
						content: 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout.'
					}
				},
				{
					name: 'inedo/slider-item',
					attributes: {
						image: {
							url: '/codex/slider.png',
							alt: ''
						},
						heading: 'Case study slider copy',
						content: 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout.'
					}
				},
				{
					name: 'inedo/slider-item',
					attributes: {
						image: {
							url: '/codex/slider.png',
							alt: ''
						},
						heading: 'Case study slider copy',
						content: 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout.'
					}
				}
			]
		},

		edit: function (props) {
			return el('div', { className: 'carousel' },
				el('div', { className: 'carousel-inner' },
					el('div', { className: 'carousel-item active' },
						el(editor.InnerBlocks, {
							allowedBlocks: ['inedo/slider-item'],
							template: [
								['inedo/slider-item', { className: 'active' }]
							],
							renderAppender: function () {
								return el(editor.InnerBlocks.ButtonBlockAppender, {});
							}
						})
					)
				),
				el('span',
					{ className: 'carousel-control-prev' },
					el('span', { className: 'carousel-control-prev-icon' })
				),
				el('span',
					{ className: 'carousel-control-next' },
					el('span', { className: 'carousel-control-next-icon' })
				)
			);
		},

		save: function (props) {
			var id = props.attributes.id || 'slider-invalid';
			if (props.innerBlocks.length) {
				props.innerBlocks.forEach(function (b) {
					delete b.attributes.className;
				});
				id = 'slider-' + props.innerBlocks[0].clientId;
				props.innerBlocks[0].attributes.className = 'active';
			}
			props.attributes.id = id;

			return el('div',
				{
					id: id,
					className: 'carousel slide',
					'data-ride': 'carousel'
				},
				el('div', { className: 'carousel-inner' },
					el(editor.InnerBlocks.Content, {})
				),
				el('a',
					{
						className: 'carousel-control-prev',
						href: '#' + id,
						role: 'button',
						'data-slide': 'prev'
					},
					el('span', { className: 'carousel-control-prev-icon', 'aria-hidden': true }),
					el('span', { className: 'sr-only' }, 'Previous')
				),
				el('a',
					{
						className: 'carousel-control-next',
						href: '#' + id,
						role: 'button',
						'data-slide': 'next'
					},
					el('span', { className: 'carousel-control-next-icon', 'aria-hidden': true }),
					el('span', { className: 'sr-only' }, 'Next')
				)
			);
		}
	});

	blocks.registerBlockType('inedo/slider-item', {
		title: 'Slider Item',
		category: 'layout',
		parent: ['inedo/slider'],

		supports: {
			reusable: false,
			html: false
		},

		attributes: {
			heading: {
				type: 'string',
				source: 'text',
				selector: 'h3'
			},
			content: {
				type: 'string',
				source: 'text',
				selector: 'p'
			},
			image: {
				type: 'object'
			}
		},

		edit: function (props) {
			return el(components.Panel, {},
				el(components.PanelBody, {},
					el(components.PanelRow, {}, imageEdit(props)),
					el(components.PanelRow, {},
						props.isSelected ? el(components.TextControl, {
							label: 'Heading',
							value: props.attributes.heading,
							onChange: function (text) {
								props.setAttributes({ heading: text });
							}
						}) : el('h3', {}, props.attributes.heading)
					),
					el(components.PanelRow, {},
						props.isSelected ? el(components.TextControl, {
							label: 'Content',
							value: props.attributes.content,
							onChange: function (text) {
								props.setAttributes({ content: text });
							}
						}) : el('p', {}, props.attributes.content)
					)
				)
			);
		},
		save: function (props) {
			return el('div', { className: 'carousel-item ' + props.className },
				el('div', { className: 'row' },
					props.attributes.image && props.attributes.image.url && el('div', { className: 'col-md-4 text-center' },
						el('div', { className: 'slider_img' },
							el('img', {
								src: props.attributes.image.url,
								alt: props.attributes.image.alt,
								className: 'img-fluid'
							})
						)
					),
					el('div', { className: 'col-md-7' },
						el('h3', {}, props.attributes.heading),
						el('p', {}, props.attributes.content)
					)
				)
			);
		}
	});

	blocks.registerBlockType('inedo/more-content', {
		title: 'More Content',
		category: 'layout',
		supports: {
			inserter: false
		},

		attributes: {
			count: {
				type: 'integer',
				default: 3
			},
			heading0: {
				type: 'string'
			},
			heading1: {
				type: 'string'
			},
			heading2: {
				type: 'string'
			},
			heading3: {
				type: 'string'
			},
			text0: {
				type: 'string'
			},
			text1: {
				type: 'string'
			},
			text2: {
				type: 'string'
			},
			text3: {
				type: 'string'
			},
			url0: {
				type: 'string'
			},
			url1: {
				type: 'string'
			},
			url2: {
				type: 'string'
			},
			url3: {
				type: 'string'
			},
			bold0: {
				type: 'boolean'
			},
			bold1: {
				type: 'boolean'
			},
			bold2: {
				type: 'boolean'
			},
			bold3: {
				type: 'boolean'
			},
			size0: {
				type: 'integer',
				default: 18
			},
			size1: {
				type: 'integer',
				default: 18
			},
			size2: {
				type: 'integer',
				default: 18
			},
			size3: {
				type: 'integer',
				default: 18
			}
		},

		example: {
			attributes: {
				count: 3,
				heading0: 'Read More #1',
				heading1: 'Read More #2',
				heading2: 'Read More #3',
				text0: 'Use your current tech stack to interact with your source code however you want across all of your systems and branches.',
				text1: 'Use your current tech stack to interact with your source code however you want across all of your systems and branches.',
				text2: 'Use your current tech stack to interact with your source code however you want across all of your systems and branches.',
				url0: '#',
				url1: '#',
				url2: '#'
			}
		},

		edit: function (props) {
			var count = props.attributes.count;

			var boxes = [];
			for (var i = 0; i < count; i++) {
				boxes.push(el('div', { className: 'col-md-' + (12 / count) },
					el('div', { className: 'box' },
						props.isSelected ? buttonEdit(props, 'heading' + i, 'url' + i, 'Link', 'size' + i, 'bold' + i, 18) : el('span', {
							className: 'heading',
							style: {
								fontSize: (props.attributes['size' + i] || 18) + 'px',
								fontWeight: props.attributes['bold' + i] ? 'bold' : 'normal'
							}
						}, props.attributes['heading' + i]),
						el(editor.RichText, {
							tagName: 'p',
							className: 'text-center',
							allowedFormats: [],
							onChange: function (i) {
								return function (content) {
									var toSet = {};
									toSet['text' + i] = content;
									props.setAttributes(toSet);
								};
							}(i),
							value: props.attributes['text' + i],
							placeholder: 'Description'
						})
					)
				));
			}

			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: 'slides',
								subscript: '2',
								title: 'Two Boxes',
								isActive: count == 2,
								onClick: function () {
									props.setAttributes({ count: 2 });
								}
							},
							{
								icon: 'slides',
								subscript: '3',
								title: 'Three Boxes',
								isActive: count == 3,
								onClick: function () {
									props.setAttributes({ count: 3 });
								}
							},
							{
								icon: 'slides',
								subscript: '4',
								title: 'Four Boxes',
								isActive: count == 4,
								onClick: function () {
									props.setAttributes({ count: 4 });
								}
							}
						]
					})
				),
				el('div', { className: 'more-content' },
					el('div', { className: 'container' },
						el('div', { className: 'row' }, boxes)
					)
				)
			];
		},
		save: function (props) {
			var count = props.attributes.count;

			var boxes = [];
			for (var i = 0; i < count; i++) {
				boxes.push(el('div', { className: 'col-md-' + (12 / count) },
					el('div', { className: 'box text-center' },
						el('a',
							{
								href: props.attributes['url' + i] || '#',
								style: {
									fontSize: (props.attributes['size' + i] || 18) + 'px',
									fontWeight: props.attributes['bold' + i] ? 'bold' : 'normal'
								},
							},
							props.attributes['heading' + i]
						),
						el(editor.RichText.Content, {
							tagName: 'p',
							value: props.attributes['text' + i]
						})
					)
				));
			}

			return el('div', { className: 'more-content' },
				el('div', { className: 'container' },
					el('div', { className: 'row' }, boxes)
				)
			);
		}
	});

	blocks.registerBlockType('inedo/boxes', {
		title: 'Inedo Boxes',
		category: 'layout',
		icon: 'grid-view',

		styles: [
			{
				name: 'light',
				label: 'Light',
				isDefault: true
			},
			{
				name: 'dark',
				label: 'Dark'
			}
		],
		attributes: {
			overlap: {
				type: 'boolean',
				default: false
			}
		},

		transforms: {
			from: [
				{
					type: 'block',
					blocks: ['inedo/key-points'],
					transform: function (attributes) {
						return blocks.createBlock('inedo/boxes', {
							className: 'is-style-light',
							overlap: attributes.overlap
						}, Array.from({ length: attributes.count }, function (_, i) {
							return blocks.createBlock('inedo/box', {
								image: attributes['image' + i],
								text: '<p>' + attributes['text' + i] + '</p>',
								url: attributes['url' + i],
								siblingCount: attributes.count
							});
						}));
					}
				},
				{
					type: 'block',
					blocks: ['inedo/more-content'],
					transform: function (attributes) {
						return blocks.createBlock('inedo/boxes', {
							className: 'is-style-dark'
						}, Array.from({ length: attributes.count }, function (_, i) {
							return blocks.createBlock('inedo/box', {
								heading: attributes['heading' + i],
								text: attributes['text' + i],
								url: attributes['url' + i],
								bold: attributes['bold' + i],
								size: attributes['size' + i],
								siblingCount: attributes.count
							});
						}));
					}
				}
			]
		},

		edit: function (props) {
			props.isSelected = props.isSelected || wp.data.select('core/block-editor').hasSelectedInnerBlock(props.clientId, true);

			var count = wp.data.useSelect(function (select) {
				return select('core/block-editor').getBlockCount(props.clientId);
			}, [props.clientId]);

			var setCount = function (newCount) {
				var innerBlocks = wp.data.select('core/block-editor').getBlocks(props.clientId).slice(0);
				while (newCount > innerBlocks.length) {
					innerBlocks.push(blocks.createBlock('inedo/box', { text: '' }));
				}
				innerBlocks = innerBlocks.slice(0, newCount);
				innerBlocks.forEach(function (b) {
					b.attributes.siblingCount = newCount;
				});
				wp.data.dispatch('core/block-editor').replaceInnerBlocks(props.clientId, innerBlocks);
			};

			if (!count) {
				setCount(3);
			}

			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: 'upload',
								title: 'Overlap Previous',
								isActive: props.attributes.overlap,
								onClick: function () {
									props.setAttributes({ overlap: !props.attributes.overlap });
								}
							}
						]
					}),
					el(components.Toolbar, {
						controls: [
							{
								icon: 'slides',
								subscript: '2',
								title: 'Two Boxes',
								isActive: count == 2,
								onClick: function () {
									setCount(2);
								}
							},
							{
								icon: 'slides',
								subscript: '3',
								title: 'Three Boxes',
								isActive: count == 3,
								onClick: function () {
									setCount(3);
								}
							},
							{
								icon: 'slides',
								subscript: '4',
								title: 'Four Boxes',
								isActive: count == 4,
								onClick: function () {
									setCount(4);
								}
							}
						]
					})
				),
				el('div', { className: props.className + ' boxes' + ((props.attributes.overlap && !props.isSelected) ? ' overlap' : '') },
					el(editor.InnerBlocks, {
						templateLock: 'all',
						allowedBlocks: ['inedo/box']
					})
				)
			];
		},
		save: function (props) {
			return el('div',
				{ className: 'boxes' + (props.attributes.overlap ? ' overlap' : '') },
				el('div', { className: 'container' },
					el('div', { className: 'row' },
						el(editor.InnerBlocks.Content, {})
					)
				)
			);
		}
	});

	blocks.registerBlockType('inedo/box', {
		title: 'Box',
		parents: ['inedo/boxes'],
		category: 'layout',
		supports: {
			inserter: false,
			reusable: false
		},

		attributes: {
			image: {
				type: 'object'
			},
			heading: {
				type: 'string',
				source: 'text',
				selector: '.heading',
				default: ''
			},
			text: {
				type: 'string',
				source: 'html',
				selector: '.body',
				multiline: 'p'
			},
			button_url: {
				type: 'string',
				default: ''
			},
			button_text: {
				type: 'string',
				default: ''
			},
			url: {
				type: 'string',
				default: ''
			},
			bold: {
				type: 'boolean',
				default: false
			},
			size: {
				type: 'integer',
				default: 18
			},
			siblingCount: {
				type: 'integer'
			}
		},

		edit: function (props) {
			var link = el(editor.URLInputButton, {
				url: props.attributes.url,
				onChange: function (url) {
					props.setAttributes({ url: url });
				}
			});
			var image = el(editor.MediaPlaceholder, {
				onSelect: function (media) {
					props.setAttributes({ image: { id: media.id, url: media.url, alt: media.alt } });
				},
				allowedTypes: ['image'],
				value: props.attributes.image,
				mediaPreview: props.attributes.image && el('img', {
					className: 'img-fluid',
					src: props.attributes.image.url
				})
			});
			var heading = el(editor.RichText, {
				tagName: 'div',
				className: 'heading',
				placeholder: 'Heading (optional)',
				style: {
					fontWeight: props.attributes.bold ? 'bold' : 'normal',
					fontSize: (props.attributes.size || 18) + 'px'
				},
				allowedFormats: [],
				withoutInteractiveFormatting: true,
				value: props.attributes.heading,
				onChange: function (value) {
					props.setAttributes({ heading: value });
				}
			});
			var body = el(editor.RichText, {
				tagName: 'div',
				className: 'body',
				multiline: 'p',
				placeholder: 'Text',
				allowedFormats: [],
				withoutInteractiveFormatting: true,
				value: props.attributes.text,
				onChange: function (value) {
					props.setAttributes({ text: value });
				}
			});
			var button = !props.attributes.url && buttonEdit(props);
			if (!props.isSelected) {
				link = null;
				image = props.attributes.image && props.attributes.image.url && el('img', {
					className: 'img-fluid',
					src: props.attributes.image.url
				});
				heading = props.attributes.heading && heading;
			}
			return [
				el(editor.InspectorControls, {},
					el(components.PanelBody, { title: 'Font Size' },
						el(components.FontSizePicker, {
							value: props.attributes.size,
							onChange: function (size) {
								props.setAttributes({ size: size || 18 });
							}
						})
					)
				),
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: 'editor-bold',
								title: 'Bold',
								isActive: props.attributes.bold,
								onClick: function () {
									props.setAttributes({ bold: !props.attributes.bold });
								}
							}
						]
					})
				),
				el('div', { className: 'box' }, link, image, heading, body, button)
			];
		},
		save: function (props) {
			var image = props.attributes.image && el('img', {
				className: 'img-fluid',
				src: props.attributes.image.url,
				alt: props.attributes.image.alt
			});
			var heading = props.attributes.heading && el(editor.RichText.Content, {
				tagName: 'div',
				className: 'heading',
				style: {
					fontWeight: props.attributes.bold ? 'bold' : 'normal',
					fontSize: (props.attributes.size || 18) + 'px'
				},
				value: props.attributes.heading
			});
			var body = el(editor.RichText.Content, {
				tagName: 'div',
				className: 'body',
				multiline: 'p',
				value: props.attributes.text
			});
			var button = !props.attributes.url && props.attributes.button_url && el('a', {
				className: 'btn btn-primary',
				href: props.attributes.button_url,
			}, props.attributes.button_text);
			var box = el('div', { className: 'box' },
				image,
				heading,
				body,
				button
			);
			if (props.attributes.url) {
				box = el('a', { href: props.attributes.url }, box);
			}

			return el('div', { className: 'col-md-' + (12 / props.attributes.siblingCount) }, box);
		}
	});

	blocks.registerBlockType('inedo/hubspot-form', {
		title: 'HubSpot Form',
		category: 'layout',
		icon: 'feedback',
		attributes: {
			formId: {
				type: 'string'
			}
		},
		edit: function (props) {
			return  props.isSelected ? el(components.TextControl, 
							{ 
								label: 'HubSpot Form ID', 
								value: props.attributes.formId, 
								onChange: function (text) {
									props.setAttributes({ formId: text});
								}
							}
						) : el('div', {}, el('span', {}, props.attributes.formId || 'Enter a HubSpot Form ID'));
		},
		save: function(props) {		
				return el('div', 
					{ 
						className: 'hs-form ' + props.attributes.className 
					}, 
					el('div', {class: 'container'},
						[
							el('script', {charset: 'utf-8', type:'text/javascript', src:'//js.hsforms.net/forms/v2.js'}),
							el('script', 
								{},
								'hbspt.forms.create({portalId: "5416872", formId: "' + props.attributes.formId + '"});'
							)
						]
					)
				);
		}
	});

	function updateCustomColor(props) {
		var settings = wp.data.select('core/block-editor').getSettings();
		var border = editor.getColorObjectByAttributeValues(settings.colors, props.attributes.color, props.attributes.customColor);
		props.attributes.customColor = border.color;
	}

	blocks.registerBlockType('inedo/notification', {
		title: 'Notification',
		category: 'layout',
		icon: 'welcome-comments',

		styles: [
			{
				name: 'thick-border',
				label: 'Thick Border',
				isDefault: true
			},
			{
				name: 'uniform-border',
				label: 'Uniform Border'
			}
		],

		attributes: {
			color: {
				type: 'string'
			},
			customColor: {
				type: 'string'
			}
		},

	    edit: function (props) {
			var useColors = editor.__experimentalUseColors([{
				name: 'color',
				property: 'borderColor'
			}]);

			return [
				useColors.InspectorControlsColorPanel,
				el(useColors.Color, {},
					el('div',
						{
							className: props.className,
							style: {
								borderColor: props.attributes.customColor
							}
						},
						el(editor.InnerBlocks, {})
					)
				)
			];
		},
		save: function (props) {
			updateCustomColor(props);

			return el('div',
				{
					style: {
						borderColor: props.attributes.customColor
					}
				},
				el(editor.InnerBlocks.Content, {})
			);
		}
	});

	blocks.registerBlockType('inedo/nav-item', {
		title: 'Nav Item',
		parents: ['inedo/sticky-nav'],
		category: 'layout',
		supports: {
			reusable: false
		},
		attributes: {
			url: {
				type: 'string'
			},
			text: {
				type: 'string'
			}
		},
		edit: function(props){
			return props.isSelected ? el(components.Panel, {},
				el(components.PanelBody, {},
					el(components.PanelRow, {},
						el(editor.URLInput, {
							label: 'URL',
							hasBorder: true,
							isFullWidth: true,
							autoFocus: false,
							value: props.attributes.url,
							onChange: function (url) {
								props.setAttributes({url: url});
							}
						})
					),
					el(components.PanelRow, {},
						el(components.TextControl, {
							label: 'Text',
							value: props.attributes.text,
							onChange: function (text) {
								props.setAttributes({text: text});
							}
						})
					)
				)
			) :  el('li', {}, el('a', {href: props.attributes.url}, props.attributes.text));
		},
		save: function(props)
		{
			return el('li', {}, el('a', {href: props.attributes.url}, props.attributes.text));
		}
	})

	blocks.registerBlockType('inedo/sticky-nav', {
		title: 'Inedo Sticky Nav',
		category: 'layout',
		example: {
			innerBlocks: [
				{
					name: 'inedo/nav-item',
					attributes: {
						url: '/',
						text: 'Example'
					}
				},
			]
		},
		edit: function(props) {
			return el('div', { class: 'tool-nav'},
				el('div', {class: 'content'},
					el('ul', {class: 'horizontal-list'},
						el(editor.InnerBlocks, {
							allowedBlocks: ['inedo/nav-item'],
							template:[['inedo/nav-item']]
						})
					)
				)

			);
		},
		save: function(props) {
			return el('div', { className: 'tool-nav'},
				el('div', {class: 'content'},
					el('ul', {class: 'horizontal-list'},
						el(editor.InnerBlocks.Content, {})
					)
				)

			);
		}
	});
	blocks.registerBlockType('inedo/toolchain', {
		title: 'Inedo Toolchain',
		category: 'layout',
		attributes: {
			product: {
				type: 'string'
			}
		},
		example: {
			attributes: {
				product: 'buildmaster'
			}
		},
		edit: function(props) {
			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: el('img', {src: '/resources/images/icons/proget-logo.svg'}),
								title: 'ProGet',
								isActive: props.attributes.product == 'proget',
								onClick: function () {
									props.setAttributes({ product: 'proget' });
								}
							},
							{
								icon: el('img', {src: '/resources/images/icons/buildmaster-logo.svg'}),
								title: 'BuildMaster',
								isActive: props.attributes.product == 'buildmaster',
								onClick: function () {
									props.setAttributes({ product: 'buildmaster' });
								}
							},
							{
								icon: el('img', {src: '/resources/images/icons/otter-logo.svg'}),
								title: 'Otter',
								isActive: props.attributes.product == 'otter',
								onClick: function () {
									props.setAttributes({ product: 'otter' });
								}
							}
						]
					})
				),
				el('object', {
					data: '/toolchain.svg#' + props.attributes.product,
					type: 'image/svg+xml',
					width: '1000',
					height: '94',
					style: {
						pointerEvents: 'none'
					}
				})
			];
		},
		save: function(props) {
			return el('object', {
				data: '/toolchain.svg#' + props.attributes.product,
				type: 'image/svg+xml',
				width: '1000',
				height: '94'
			});
		}
	});
	function pricingLayout(product) {
		switch (product) {
			case 'proget':
				return el('div', {className: 'pricing-box-container pricing-proget alignfull'},
					el('div', {id: 'free', className: 'pricing-box thin pg'},
						el('h2', {}, 'ProGet', el('br'), 'Free'),
						el('hr'),
						el('div', {className: 'copy'},
							el('p', {}, 'ProGet Free has no user limit and includes all the same feed types as ProGet Enterprise.'),
						),
						el('a', {className: 'download', href: '/proget/download'},
							'Download Now'),
					),
					el('div', {id: 'enterprise', className: 'pricing-box pg'},
						el('h2', {}, 'ProGet', el('br'), 'Enterprise'),
						el('hr'),
						el('div', {className: 'copy'},
							el('p', {style: {marginBottom: '0px'}}, 'Starting at'),
							el('h2', {style: {marginTop: '0px'}}, '$9,995/yr'),
							el('p', {style: {marginTop: '0px'}}, 'per instance')
						),
						el('a', {className: 'download', href: '/proget/pricing/request-quote'},
							'Request a quote')
					),
					el('div', {id: 'basic', className: 'pricing-box thin pg'},
						el('h2', {}, 'ProGet', el('br'), 'Basic'),
						el('hr'),
						el('div', {className: 'copy'},
							el('h2', {}, '$1,995/yr'),
							el('p', {}, 'per server')
						),
						el('a', {className: 'download', href: 'https://my.inedo.com/'},
							'Buy Now')
					)
				);
			case 'buildmaster':
			case 'otter':
				var productCaps = product == 'buildmaster' ? 'BuildMaster' : 'Otter';
				var freeCopy = product == 'buildmaster' ? 'Unlimited users, unlimited applications, and unlimited servers. All logged-in users are administrators, LDAP integration is disabled, and you can only use our public forums for support.' : 'Otter Free has no server limit and includes all of the features of Otter Enterprise, but gives all users unrestricted access.';
				var tieredItem = product == 'buildmaster' ? 'Users' : 'Servers';
				return el('div', {className: 'pricing-box-container pricing-' + product },
					el('div', {className: 'pricing-box free'},
						el('h2', {}, productCaps + ' Free'),
						//product == 'buildmaster' ? null : el('hr'),
						el('div', {className: 'copy'},
							el('p', {}, freeCopy)
						),
						el('a', {href: '/' + product + '/download'}, 'Download')
					),
					' ',
					el('div', {className: 'pricing-box enterprise'},
						el('h2', {}, productCaps + ' Enterprise'),
						el('div', { className: 'pricing-box-blocks'},
							el('div', {className: 'pricing-block left'},
								el('h2', {}, '$2,995/yr'),
								el('p', {}, 'Up to 10', el('br'), tieredItem)
							),
							el('div', {className: 'pricing-block'},
								el('h2', {}, '$4,495/yr'),
								el('p', {}, 'Up to 20', el('br'), tieredItem)
							),
							el('div', {className: 'pricing-block'},
								el('h2', {}, '$7,495/yr'),
								el('p', {}, 'Up to 35', el('br'), tieredItem)
							),
							el('div', {className: 'pricing-block'},
								el('h2', {}, '$9,745/yr'),
								el('p', {}, 'Up to 50', el('br'), tieredItem)
							),
							el('div', {className: 'pricing-block'},
								el('h2', {}, '$14,995/yr'),
								el('p', {}, 'Up to 100', el('br'), tieredItem)
							),
							el('div', {className: 'pricing-block'},
								el('h2', {}, '$29,995/yr'),
								el('p', {}, 'Up to 250', el('br'), tieredItem)
							)
						),
						el('div', {className: 'pricing-block custom'},
							el('h2', {}, 'Request a Custom Quote for over 250 ' + tieredItem)
						),
						el('br'),
						el('a', {href: '/' + product + '/pricing/request-quote'}, 'Request a Quote'),
						el('a', {href: 'https://my.inedo.com/'}, 'Buy Now')
					)
				);
			default:
				return el('div', {className: 'info-box error'}, 'no product selected');
		}
	}
	blocks.registerBlockType('inedo/pricing', {
		title: 'Inedo Pricing',
		category: 'layout',
		attributes: {
			product: {
				type: 'string'
			}
		},
		example: {
			attributes: {
				product: 'buildmaster'
			}
		},
		edit: function(props) {
			return [
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: el('img', {src: '/resources/images/icons/proget-logo.svg'}),
								title: 'ProGet',
								isActive: props.attributes.product == 'proget',
								onClick: function () {
									props.setAttributes({ product: 'proget' });
								}
							},
							{
								icon: el('img', {src: '/resources/images/icons/buildmaster-logo.svg'}),
								title: 'BuildMaster',
								isActive: props.attributes.product == 'buildmaster',
								onClick: function () {
									props.setAttributes({ product: 'buildmaster' });
								}
							},
							{
								icon: el('img', {src: '/resources/images/icons/otter-logo.svg'}),
								title: 'Otter',
								isActive: props.attributes.product == 'otter',
								onClick: function () {
									props.setAttributes({ product: 'otter' });
								}
							}
						]
					})
				),
				pricingLayout(props.attributes.product)
			];
		},
		save: function(props) {
			return pricingLayout(props.attributes.product);
		}
	});

	function downloadLayout(product, version, button, innerBlocks) {
		var capsName = ({
			buildmaster: 'BuildMaster',
			otter: 'Otter',
			proget: 'ProGet'
		})[product] || product;
		return el('div', {className: 'inedo-downloads-wrapper downloads-product-' + product},
			el('div', {className: 'inedo-downloads-primary'},
				el('h2', {}, 'Windows Download'),
				el('p', {},
					el('img', {className: 'logo', src: '/resources/images/logos/inedo-hub.svg', alt: 'Inedo Hub'})
				),
				el('p', {}, capsName + ' on Windows is managed by the Inedo\u00a0Hub'),
				button,
				el('p', {className: 'help-links'}, el('a', {
					href: '#getting-started-windows'
				}, 'Getting Started'), ' \u2022 ', el('a', {
					href: '/' + product + '/license-agreement',
					className: 'external'
				}, 'EULA'))
			),
			el('div', {className: 'inedo-downloads-secondary'},
				el('ul', {},
					el('li', {}, 'File size: < 1 MB'),
					el('li', {}, el('a', {
						className: 'external',
						href: 'https://inedo.com/' + product + '/' + version
					}, 'Release overview'), ' for ', version),
					el('li', {}, el('a', {
						className: 'external',
						href: 'https://my.inedo.com/' + product + '/versions#v' + version
					}, 'Release notes')),
					el('li', {}, el('a', {
						className: 'external',
						href: 'https://my.inedo.com/' + product + '/versions'
					}, 'Previous versions'))
				)
			),
			el('div', {className: 'inedo-downloads-tertiary'},
				innerBlocks
			)
		);
	}
	blocks.registerBlockType('inedo/product-downloads', {
		title: 'Inedo Product Downloads',
		category: 'layout',
		attributes: {
			product: {
				type: 'string',
				default: 'buildmaster'
			},
			version: {
				type: 'string',
				default: '6.2'
			},
			button_text: {
				type: 'string',
				default: 'Download Inedo Hub'
			},
			button_url: {
				type: 'string'
			},
			button_style: {
				type: 'string',
				default: 'is-style-btn-primary'
			}
		},
		example: {
		},
		edit: function(props) {
			return [
				el(editor.InspectorControls, {  },
					el(components.Panel, {},
						el(components.PanelBody, {},
							el(components.PanelRow, {},
								el(components.TextControl, {
									label: 'Download Version',
									value: props.attributes.version,
									onChange: function (text) {
										var toSet = {};
										toSet.version = text;
										props.setAttributes(toSet);
									}
								})
							)
						)
					)
				),
				el(editor.BlockControls, {},
					el(components.Toolbar, {
						controls: [
							{
								icon: el('img', {src: '/resources/images/icons/proget-logo.svg'}),
								title: 'ProGet',
								isActive: props.attributes.product == 'proget',
								onClick: function () {
									props.setAttributes({ product: 'proget' });
								}
							},
							{
								icon: el('img', {src: '/resources/images/icons/buildmaster-logo.svg'}),
								title: 'BuildMaster',
								isActive: props.attributes.product == 'buildmaster',
								onClick: function () {
									props.setAttributes({ product: 'buildmaster' });
								}
							},
							{
								icon: el('img', {src: '/resources/images/icons/otter-logo.svg'}),
								title: 'Otter',
								isActive: props.attributes.product == 'otter',
								onClick: function () {
									props.setAttributes({ product: 'otter' });
								}
							}
						]
					})
				),
				props.isSelected ? [
					buttonEdit(props, null, null, null, null, null, null, null, null, 'button_style', 'button_cta'),
					el(editor.InnerBlocks, {
						template: [
							['core/heading', {level: 3}],
							['core/paragraph', {}]
						]
					})
				]: downloadLayout(props.attributes.product, props.attributes.version, buttonEdit(props), el(editor.InnerBlocks, {
					template: [
						['core/heading', {level: 3}],
						['core/paragraph', {}]
					]
				}))
			];
		},
		save: function(props) {
			return downloadLayout(props.attributes.product, props.attributes.version, el('div', {'className': props.attributes.button_style }, buttonSave(props.attributes, null, null, 'button_cta', '')), el(editor.InnerBlocks.Content));
		}
	});

	
})(
	window.wp.blocks,
	window.wp.blockEditor,
	window.wp.i18n,
	window.wp.element,
	window.wp.components,
	window._
);

window.wp.domReady(function()
{
	window.wp.blocks.registerBlockStyle( 'core/columns', [
		{
			name: 'default',
			label: 'Default',
			isDefault: true,
		},
		{
			name: 'two-columns',
			label: 'Two Columns',
			isDefault: false,
		},
		{
			name: 'three-columns',
			label: 'Three Columns',
			isDefault: false,
		},
		{
			name: 'four-columns',
			label: 'Four Columns' ,
			isDefault: false,
		} 
	]);

	// window.wp.blocks.registerBlockStyle( 'core/column', [
	// 	{
	// 		name: 'default',
	// 		label: 'Default',
	// 		isDefault: true,
	// 	},
	// 	{
	// 		name: 'grey-blocks',
	// 		label: 'Grey Boxes',
	// 		isDefault: false,
	// 	}
	// ]);
});
